#include <sourcemod>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name = "DoD Anti-JumpShot",
	author = "FeuerSturm",
	description = "Prevent players from hopping around and shooting",
	version = "1.1",
	url = "http://www.dodsourceplugins.net"
}

new Handle:AntiJumpShot = INVALID_HANDLE
new Float:g_LastJump[MAXPLAYERS+1] = -1.0

public OnPluginStart()
{
	AntiJumpShot = CreateConVar("dod_antijumpshot", "1", "<1/0> = enable/disable Anti-JumpShot", FCVAR_PLUGIN, true, 0.0, true, 1.0)
}

public OnClientDisconnect(client)
{
	g_LastJump[client] = -1.0
	SDKUnhook(client, SDKHook_PreThink, OnPreThink)
	SDKUnhook(client, SDKHook_WeaponCanSwitchTo, OnWeaponCanSwitchTo)
}

public OnClientPutInServer(client)
{
	g_LastJump[client] = -1.0
	SDKHook(client, SDKHook_PreThink, OnPreThink)
	SDKHook(client, SDKHook_WeaponCanSwitchTo, OnWeaponCanSwitchTo)
}

public Action:OnWeaponCanSwitchTo(client, weapon)
{
	if(GetGameTime() < g_LastJump[client] + 1.0 && g_LastJump[client] != -1.0)
	{
		return Plugin_Handled
	}
	return Plugin_Continue
}

public OnPreThink(client)
{
	if(GetConVarInt(AntiJumpShot) == 1)
	{
		if(IsValidEntity(client) && IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) > 1)
		{
			new buttons = GetClientButtons(client)
			if(buttons & IN_JUMP)
			{
				if(!(buttons & IN_MOVELEFT) && !(buttons & IN_MOVERIGHT) && !(buttons & IN_BACK) && buttons & IN_FORWARD)
				{
					return
				}
				decl String:CurrWeapon[32]
				GetClientWeapon(client, CurrWeapon, sizeof(CurrWeapon))
				if(StrContains(CurrWeapon, "weapon_frag_", true) == -1 && StrContains(CurrWeapon, "weapon_smoke_", true) == -1 && StrContains(CurrWeapon, "_live", true) == -1)
				{
					SetEntPropFloat(client, Prop_Send, "m_flNextAttack", GetGameTime()+1.0)
					g_LastJump[client] = GetGameTime()
				}
			}
		}
	}
}